#!/bin/sh
#
EVENT="$1"
UDI="$2"
LOGGER="logger -t `basename $0`"
FACILITY="user"
ERROR="${LOGGER} -p ${FACILITY}.err"
WARNING="${LOGGER} -p ${FACILITY}.warning"
NOTICE="${LOGGER} -p ${FACILITY}.notice"
INFO="${LOGGER} -p ${FACILITY}.info"
DEBUG="${LOGGER} -p ${FACILITY}.debug"
IFCONFIG="/sbin/ifconfig"

add() {
  [ -z "$UDI" ] && exit 1
  IFACE=`hal-get-property --udi $UDI --key net.interface`
  [ -z "$IFACE" ] && exit 3
  
  $IFCONFIG $IFACE 169.254.2.2 netmask 255.255.255.0
  
  $INFO "PocketPC device $IFACE connected "
}

remove() {
  $INFO "PocketPC device removed"
}

case "$EVENT" in
  add)
    add
    ;;
  remove)
    remove
    ;;
  *)
    echo "usage: $0 {add|remove} uid"
esac

exit 0