/*
 * $Id: DccmServer.cs 258 2007-06-02 06:54:08Z lloydd $
 */
 
using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using Mono.Unix;
using Mono.GetOptions;
using NDesk.DBus;
using org.freedesktop.DBus;
using org.wimo.dccm;

namespace Dccm
{
   public class RapiForwardServer
   {
      TcpClient device;
      TcpListener server;
      uint req_id;
      string ip;
      Thread thread;
      
      public RapiForwardServer (TcpClient device, int rapi_port)
      {
         thread = null;
         req_id = 0;
         this.device = device;
         ip = ((IPEndPoint) device.Client.RemoteEndPoint).Address.ToString ();
         server = new TcpListener (IPAddress.Any, rapi_port);
         server.Start ();
      }

      public void Start ()
      {
         thread = new Thread (new ThreadStart (Handler));
         
         thread.Start ();
      }
      
      public void Stop ()
      {
         if (thread == null)
            return;
         
         thread.Abort ();
         
         thread = null;
      }
      
      public void Handler ()
      {
         while (true) {

            if (MainClass.Opt.Debug)
               Console.WriteLine ("Accepting new client connection");
            
            TcpClient client = server.AcceptTcpClient ();

            if (MainClass.Opt.Debug) {
               
               Console.WriteLine ("New client connection accepted");
               Console.WriteLine ("Requesting on device new connection");
            }
            
            ++req_id;
            
            RapiServer.PushRequest (ip, client, req_id);
            
            RequestNewConnection (device, req_id);

            if (MainClass.Opt.Debug)
               Console.WriteLine ("Accepting new device connection for client");
         }
      }
      
      public void RequestNewConnection (TcpClient device, uint req_id)
      {
         byte[] tmp = null;
         byte[] buf = new byte [3 * sizeof (uint)];
         
         tmp = BitConverter.GetBytes ((uint) 5);
         tmp.CopyTo (buf, 0 * sizeof (uint));
         
         tmp = BitConverter.GetBytes ((uint) 4);
         tmp.CopyTo (buf, 1 * sizeof (uint));
         
         tmp = BitConverter.GetBytes ((uint) req_id);
         tmp.CopyTo (buf, 2 * sizeof (uint));
         
         device.GetStream ().Write (buf, 0, buf.Length);
      }
   }
}
