/*
 * $Id: Utilities.cs 86 2007-03-28 13:19:41Z lloydd $
 */

using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Diagnostics;
using System.Text;
using Mono.Unix;
 
public static class Utilities
{    
   public static int ExecProcess (string command, string format, params object[] args)
   {
      string arg = string.Format (format, args);
      Process process = Process.Start (command, arg == null ? "" : arg);
      process.WaitForExit ();
      return process.ExitCode;
   }
   
   [DllImport("libc")]
   private static extern int prctl (int option, byte [] arg2, IntPtr arg3, IntPtr arg4, IntPtr arg5);
   
   public static void SetProcessName (string name)
   {
      if (prctl (15, // PR_SET_NAME
            Encoding.ASCII.GetBytes (name + "\0"), 
            IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) != 0) {
      
         throw new ApplicationException (Catalog.GetString ("Error setting process name: ") + 
            Mono.Unix.Native.Stdlib.GetLastError ());
      }
   }
}

