/*
 * $Id: TestFilesystem.cs 120 2007-04-04 14:15:38Z lloydd $
 */

using System;
using System.IO;
using System.Threading;
using System.Text;
using System.Net;
using System.Net.Sockets;

public class PPC_WM2003
{
   static string Server = "127.0.0.1";
   static int Port = 5679;
   
   static TcpClient client = null;
   static NetworkStream stream = null;
   
   public static void Main (string[] args)
   {
      int len = 0;
      byte[] sz = null;
      byte[] buf = null;
      
      try {
         client = new TcpClient ();
         client.Client.SetSocketOption (SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 4000);
         client.Client.SetSocketOption (SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 4000);
         client.Connect (Server, Port);
         client.Client.SetSocketOption (SocketOptionLevel.Socket, SocketOptionName.KeepAlive, 15000);

         if (!client.Connected)
            throw new Exception ("Connect failed");
         
         stream = client.GetStream ();
         
         // no password is requested
//         sz = BitConverter.GetBytes ((UInt32) 0);
//         Stream.Write (sz, 0, sz.Length);

         // password requested
         sz = BitConverter.GetBytes ((UInt32) 77446582);
         stream.Write (sz, 0, sz.Length);
         
         buf = new byte [146] {
            0x28, 0x00, 0x00, 0x00, 0x04, 0x15, 0x40, 0x04,
            0x11, 0x0A, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00,
            0x73, 0xA7, 0x7D, 0x49, 0x00, 0x00, 0x00, 0x00,
            0x28, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00,
            0x4E, 0x00, 0x00, 0x00, 0x72, 0x00, 0x00, 0x00,
            0x50, 0x00, 0x44, 0x00, 0x41, 0x00, 0x00, 0x00,
            0x50, 0x00, 0x6F, 0x00, 0x63, 0x00, 0x6B, 0x00,
            0x65, 0x00, 0x74, 0x00, 0x50, 0x00, 0x43, 0x00,
            0x00, 0x00, 0x53, 0x00, 0x53, 0x00, 0x44, 0x00,
            0x4B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x00,
            0x63, 0x00, 0x65, 0x00, 0x72, 0x00, 0x20, 0x00,
            0x6E, 0x00, 0x35, 0x00, 0x30, 0x00, 0x20, 0x00,
            0x48, 0x00, 0x61, 0x00, 0x6E, 0x00, 0x64, 0x00,
            0x68, 0x00, 0x65, 0x00, 0x6C, 0x00, 0x64, 0x00,
            0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x01, 0x00,
            0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x15, 0x00,
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
            0x00, 0x00 };
         
         sz = BitConverter.GetBytes ((UInt32) buf.Length);
         stream.Write (sz, 0, sz.Length);
         stream.Write (buf, 0, buf.Length);
         
         buf = new byte [sizeof (ushort)];
         if (stream.Read (buf, 0, sizeof (ushort)) != sizeof (ushort))
            throw new Exception ("Failed to read response size");
         
         len = (ushort) BitConverter.ToUInt16 (buf, 0);
         
         byte key = 182;
         
         Console.WriteLine ("Password response size:{0}", len);

         buf = new byte [len];
         if (stream.Read (buf, 0, len) != len)
            throw new Exception ("Failed to read password");
      
         for (int i = 0; i < len; i++)
            buf [i] = (byte)(buf [i] ^ key);
         
         string psw = Encoding.Unicode.GetString (buf, 0, len - 2);
         
         Console.WriteLine ("Password:\"{0}\"", psw);
         
         bool psw_ok = psw == "1111";
         
         if (psw_ok)
            buf = BitConverter.GetBytes ((UInt16) 1);
         else
            buf = BitConverter.GetBytes ((UInt16) 0);
         
         stream.Write (buf, 0, buf.Length);
         
         if (psw_ok) {
            
            buf = new byte [sizeof (uint)];
            sz = BitConverter.GetBytes ((UInt32) 0x12345678);
            
            while (true) {
            
               Console.WriteLine ("Waiting...");
               stream.Read (buf, 0, buf.Length);
               
               Console.WriteLine ("Received data, send ping...");
               stream.Write (sz, 0, sz.Length);

               Thread.Sleep (1000);
            }
         }
      }
      catch (Exception e) {
         
         throw new Exception (string.Format (
            "TCP connect to DCCM server {0}:{1} failed: {2}", Server, Port, e.Message));
      }
   }
}
